//+------------+-----------------------------------------------------+
//| v.11.02.07 |                                            ZZx2.mq4 |
//+------------+                                                     |
//|------------|              Bookkeeper, 2007, yuzefovich@gmail.com |
//+------------+-----------------------------------------------------+
#property copyright ""
#property link      "http://www.forexter.land.ru/indicators.htm"
//----
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  FireBrick
#property indicator_color2  BlueViolet
#property indicator_color3  Blue
#property indicator_color4  Blue
#property indicator_color5  Blue
#property indicator_color6  Navy
//--------------------------------------------------------------------
extern int    SR  =3;
extern int    LR  =11;
extern int    SRZZ=4;
extern int    LRZZ=12;
extern int    FP  =21;
extern int    SMF =5;
extern int    LMF =2;
//--------------------------------------------------------------------
double        SZZ[];
double        LZZ[];
double        SA[];
double        LA[];
double        SM[];
double        LM[];
//---------------------------------------------------------------------
double TSZZ=0, TLZZ=0, TCH=0, TS=0;
int TF[5]={0,0,0,0,0};
int MaxBar, nSBZZ, nLBZZ, SBZZ, LBZZ;
bool First=true;
int prevBars=0;
string OName="ZZx2_";
//---------------------------------------------------------------------
void deinit() { int N,i; string SStr,NO;
Comment(""); N=ObjectsTotal(); for(i=N;i>=0;i--) {
NO=ObjectName(i); SStr=StringSubstr(NO,0,5);
if(SStr==OName) ObjectDelete(NO); } return; }
//---------------------------------------------------------------------
int init()
{
   IndicatorBuffers  (6);
   SetIndexBuffer    (0,SZZ);
   SetIndexStyle     (0,DRAW_SECTION,EMPTY,2);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer    (1,LZZ);
   SetIndexStyle     (1,DRAW_SECTION,EMPTY,2);
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer    (2,SA);
   SetIndexStyle     (2,DRAW_NONE);
   SetIndexBuffer    (3,LA);
   SetIndexStyle     (3,DRAW_NONE);
   SetIndexBuffer    (4,SM); 
   SetIndexStyle     (4,DRAW_NONE);
   SetIndexBuffer    (5,LM); 
   SetIndexStyle     (5,DRAW_NONE);
   return(0);
}
//---------------------------------------------------------------------
int start() { int counted_bars=IndicatorCounted(); int limit,i,j,n;
if(counted_bars<0) return(-1); if(counted_bars>0) counted_bars--;
if(prevBars!=Bars) { 
if(First==true) { 
if(Bars<=2*(LRZZ+FP+LR+2)) return(-1); 
if(SR<2) SR=2;
if(SRZZ<=SR) SRZZ=SR+1; MaxBar=Bars-(LRZZ+FP+LR+2); 
nLBZZ=LRZZ+FP+LR+2; nSBZZ=nLBZZ; 
First=false; }
limit=Bars-counted_bars; 
SBZZ=Bars-nSBZZ; LBZZ=Bars-nLBZZ;
prevBars=Bars; }
for(i=limit;i>=0;i--) { MainCalculation(i); }
LZZCalc(0); SZZCalc(0); 
return(0); }
//---------------------------------------------------------------------
void MainCalculation(int Pos) {
if((Bars-Pos)>(SR+1)) SACalc(Pos); else SA[Pos]=0; 
if((Bars-Pos)>(LR+1)) LACalc(Pos); else LA[Pos]=0; 
if((Bars-Pos)>(FP+SR+2)) SMCalc(Pos); else SM[Pos]=0; 
if((Bars-Pos)>(FP+LR+2)) LMCalc(Pos); else LM[Pos]=0; return; }
//---------------------------------------------------------------------
void SACalc(int Pos) { int sw, i, w, ww, Shift; double sum;
//SA[Pos]=iMA(NULL,0,SR+1,0,MODE_LWMA,PRICE_WEIGHTED,Pos);
SA[Pos]=iMA(NULL,0,SR+1,0,MODE_LWMA,PRICE_OPEN,Pos);
for(Shift=Pos+SR+2;Shift>Pos;Shift--) { sum=0.0; sw=0; i=0; w=Shift+SR;
ww=Shift-SR; if(ww<Pos) ww=Pos;
while(w>=Shift) {i++; sum=sum+i*SPrice(w); sw=sw+i; w--; }
while(w>=ww) { i--; sum=sum+i*SPrice(w); sw=sw+i; w--; }
SA[Shift]=sum/sw; } return; }
//----
void LACalc(int Pos) { int sw, i, w, ww, Shift; double sum;
LA[Pos]=iMA(NULL,0,LR+1,0,MODE_LWMA,PRICE_OPEN,Pos);
for(Shift=Pos+LR+2;Shift>Pos;Shift--) { sum=0.0; sw=0; i=0; w=Shift+LR;
ww=Shift-LR; if(ww<Pos) ww=Pos;
while(w>=Shift) {i++; sum=sum+i*SPrice(w); sw=sw+i; w--; }
while(w>=ww) { i--; sum=sum+i*SPrice(w); sw=sw+i; w--; }
LA[Shift]=sum/sw; } return; }
//----
double SPrice(int i) { return(Open[i]); }
//---------------------------------------------------------------------
void SMCalc(int i) { double t, b;
for(int Shift=i+SR+2;Shift>=i;Shift--) {
t=SA[ArrayMaximum(SA,FP,Shift)]; b=SA[ArrayMinimum(SA,FP,Shift)];
SM[Shift]=(2*(2+SMF)*SA[Shift]-(t+b))/2/(1+SMF); } return; }
//----
void LMCalc(int i) { double t, b;
for(int Shift=i+LR+2;Shift>=i;Shift--) {
t=LA[ArrayMaximum(LA,FP,Shift)]; b=LA[ArrayMinimum(LA,FP,Shift)];
LM[Shift]=(2*(2+LMF)*LA[Shift]-(t+b))/2/(1+LMF); } return; }
//---------------------------------------------------------------------
void LZZCalc(int Pos) { 
int LTF[5]={0,0,0,0,0},i,RBar,LBar,ZZ,NZZ,NZig,NZag; 
i=Pos-1; NZig=0; NZag=0;
while(i<MaxBar && ZZ==0) { i++; LZZ[i]=0; RBar=i-LRZZ; 
if(RBar<Pos) RBar=Pos; LBar=i+LRZZ;
if(i==ArrayMinimum(LM,LBar-RBar+1,RBar)) { ZZ=-1; NZig=i; }
if(i==ArrayMaximum(LM,LBar-RBar+1,RBar)) { ZZ=1;NZag=i; } }
if(ZZ==0) return; NZZ=0;
if(i>Pos) { if(LM[i]>LM[Pos]) { if(ZZ==1) {
if(i>=Pos+LRZZ && NZZ<4) { NZZ++; LTF[NZZ]=i; } NZag=i; LZZ[i]=LM[i]; } }
else { if(ZZ==-1) { if(i>=Pos+LRZZ && NZZ<4) { NZZ++; LTF[NZZ]=i; }
NZig=i; LZZ[i]=LM[i]; } } }
while(i<(Bars-nLBZZ) || NZZ<4) {  LZZ[i]=0; RBar=i-LRZZ; 
if(RBar<Pos) RBar=Pos; LBar=i+LRZZ;
if(i==ArrayMinimum(LM,LBar-RBar+1,RBar)) {
if(ZZ==-1 && LM[i]<LM[NZig]) { 
if(i>=Pos+LRZZ && NZZ<4) LTF[NZZ]=i; LZZ[NZig]=0; LZZ[i]=LM[i]; NZig=i; }
if(ZZ==1) { if(i>=Pos+LRZZ && NZZ<4) { NZZ++; LTF[NZZ]=i; } 
LZZ[i]=LM[i]; ZZ=-1; NZig=i; } }
if(i==ArrayMaximum(LM,LBar-RBar+1,RBar)) {
if(ZZ==1 && LM[i]>LM[NZag]) { 
if(i>=Pos+LRZZ && NZZ<4) LTF[NZZ]=i; LZZ[NZag]=0; LZZ[i]=LM[i]; NZag=i; }
if(ZZ==-1) { if(i>=Pos+LRZZ && NZZ<4) { NZZ++; LTF[NZZ]=i; } 
LZZ[i]=LM[i]; ZZ=1; NZag=i; } } i++; if(i>MaxBar) return; } 
nLBZZ=Bars-LTF[4]; LZZ[Pos]=LM[Pos]; return; }
//----
void SZZCalc(int Pos) { 
int STF[5]={0,0,0,0,0},i,RBar,LBar,ZZ,NZZ,NZig,NZag; 
i=Pos-1; NZig=0; NZag=0;
while(i<MaxBar && ZZ==0) { i++; SZZ[i]=0; RBar=i-SRZZ; 
if(RBar<Pos) RBar=Pos; LBar=i+SRZZ;
if(i==ArrayMinimum(SM,LBar-RBar+1,RBar)) { ZZ=-1; NZig=i; }
if(i==ArrayMaximum(SM,LBar-RBar+1,RBar)) { ZZ=1; NZag=i; } }
if(ZZ==0) return; NZZ=0;
if(i>Pos) { if(SM[i]>SM[Pos]) { if(ZZ==1) {
if(i>=Pos+SRZZ && NZZ<4) { NZZ++; STF[NZZ]=i; } NZag=i; SZZ[i]=SM[i]; } }
else { if(ZZ==-1) { if(i>=Pos+SRZZ && NZZ<4) { NZZ++; STF[NZZ]=i; }
NZig=i; SZZ[i]=SM[i]; } } }
while(i<(Bars-nSBZZ) || NZZ<4) {  SZZ[i]=0; RBar=i-SRZZ; 
if(RBar<Pos) RBar=Pos; LBar=i+SRZZ;
if(i==ArrayMinimum(SM,LBar-RBar+1,RBar)) {
if(ZZ==-1 && SM[i]<SM[NZig]) { 
if(i>=Pos+SRZZ && NZZ<4) STF[NZZ]=i; SZZ[NZig]=0; SZZ[i]=SM[i]; NZig=i; }
if(ZZ==1) { if(i>=Pos+SRZZ && NZZ<4) { NZZ++; STF[NZZ]=i; } 
SZZ[i]=SM[i]; ZZ=-1; NZig=i;  } }
if(i==ArrayMaximum(SM,LBar-RBar+1,RBar)) {
if(ZZ==1 && SM[i]>SM[NZag]) { 
if(i>=Pos+SRZZ && NZZ<4) STF[NZZ]=i; SZZ[NZag]=0; SZZ[i]=SM[i]; NZag=i; }
if(ZZ==-1) { if(i>=Pos+SRZZ && NZZ<4) { NZZ++; STF[NZZ]=i; } 
SZZ[i]=SM[i]; ZZ=1; NZag=i; } } i++; if(i>MaxBar) return; } 
nSBZZ=Bars-STF[4]; SZZ[Pos]=SM[Pos]; return; }
//---------------------------------------------------------------------

